MODULE PipeNul;

        (********************************************************)
        (*                                                      *)
        (*      Sending named pipe output to a black hole       *)
        (*          This program has no screen output           *)
        (*                                                      *)
        (*    Started:        25 April 2004                     *)
        (*    Last edited:    26 April 2004                     *)
        (*    Status:         OK                                *)
        (*                                                      *)
        (********************************************************)

IMPORT OS2, TextIO, Strings;

FROM SYSTEM IMPORT
    (* proc *)  ADR;

FROM ProgramArgs IMPORT
    (* proc *)  ArgChan, IsArgPresent;

FROM IOChan IMPORT
    (* type *)  ChanId;

(************************************************************************)

CONST
    Nul = CHR(0);
    BufferSize = 256;

(************************************************************************)

PROCEDURE ProcessArgument (VAR (*OUT*) PipeName: ARRAY OF CHAR);

    (* Reads program argument "pipename", returns the pipe name.  *)

    VAR Buffer: ARRAY [0..BufferSize-1] OF CHAR;
        pos: CARDINAL;
        args: ChanId;  found: BOOLEAN;

    BEGIN
        args := ArgChan();
        IF IsArgPresent() THEN
            TextIO.ReadString (args, Buffer);
        ELSE
            Buffer := "WeaselTransLog";
        END (*IF*);
        pos := 0;
        Strings.FindNext (' ', Buffer, 0, found, pos);
        Strings.Assign ("\PIPE\", PipeName);
        Strings.Append (Buffer, PipeName);
        IF found THEN
            PipeName[pos+6] := Nul;
        END (*IF*);
    END ProcessArgument;

(************************************************************************)

PROCEDURE DoTheJob;

    CONST
        OpenFlags = OS2.OPEN_ACTION_FAIL_IF_NEW
                    + OS2.OPEN_ACTION_OPEN_IF_EXISTS;
        Mode = OS2.OPEN_FLAGS_FAIL_ON_ERROR + OS2.OPEN_FLAGS_SEQUENTIAL
                + OS2.OPEN_SHARE_DENYNONE
                + OS2.OPEN_FLAGS_NOINHERIT
                + OS2.OPEN_ACCESS_READONLY;

    VAR rc, Action, NumberRead: CARDINAL;
        hpipe: OS2.HPIPE;
        Waiting: BOOLEAN;
        PipeName, Buffer: ARRAY [0..BufferSize-1] OF CHAR;

    BEGIN
        (* Read the argument to get a pipe name. *)

        ProcessArgument (PipeName);

        (* Wait for the input pipe to be open. *)

        REPEAT
            rc := OS2.DosOpen (PipeName, hpipe, Action, 0, 0, OpenFlags, Mode, NIL);
            Waiting := rc = 3;
            IF Waiting THEN
                OS2.DosSleep (200);
            END (*IF*);
        UNTIL NOT Waiting;

        (* Read the data but do nothing with it. *)

        IF rc = 0 THEN
            REPEAT
                IF OS2.DosRead (hpipe, ADR(Buffer),
                                    BufferSize, NumberRead) <> 0 THEN
                    NumberRead := 0;
                END (*IF*);
            UNTIL NumberRead = 0;
            OS2.DosClose (hpipe);
        END (*IF*);
    END DoTheJob;

(************************************************************************)

BEGIN
    DoTheJob;
END PipeNul.

